# Contrôle TP 2025

Ce contrôle TP est d'une durée de 2h. L’usage des documents papier et des précédents TP sont
autorisés. **Attention: toute modification de votre dépôt strictement postérieure à
l'heure limite de la remise sera ignorée**. Vous devez bien entendu soumettre un travail
original, dont vous êtes l'unique auteur.

# Déroulement du contrôle

## À faire immédiatement!

### 1) Commencez par `fork` ce dépôt. 

**Assurez-vous qu'il est privé** (sinon, sur la page de votre fork sur gitlab, allez dans `Settings` --> `General` --> `Visibility, project features, permissions` --> `expand` --> `Project visibility` --> sélectionner `Private`).

### 2) Invitez immédiatement votre enseignant comme membre **DEVELOPPEUR** sur votre dépôt gitlab (que vous venez juste de fork)

### 3) Compilez le projet et assurez-vous qu'il se lance sans erreur de compilation dans l'AVD. Dans le cas contraire avertissez immédiatement l'enseignant.

### 4) Activer la compilation hors-ligne
Cliquez sur le bouton `Toggle Offline Mode` de l'onglet Gradle comme indiqué sur cette capture d'écran:

<img src="img/offlline.png" alt="image" style="width:200px"/>

## Description du dépôt

Ce dépôt contient:

- ce sujet de contrôle TP
- l'ensemble des sources et ressources dont vous aurez besoin pour ce contrôle.

Un jeu d'essai est préchargé à partir du fichier json (présent comme une ressource 'raw' de nom cand.json).

La commande

```{shell}
/usr/local/virtual_machine/infoetu/android/<login>/Sdk/platform-tools/adb install ./demo.apk
```

exécutée depuis le volet 'Terminal' installe une version complète du programme sur votre android virtuel (pensez évidemment à remplacer <login> par votre login).

## Restitution

**Vous enregistrerez l'état de votre projet après chaque question (votre projet doit compiler et être fonctionnel).**

```{shell}
git commit -am 'Question X'
git tag Qx
git push --tag 
```

## Rappels git

La commande:

```{shell}
git config --global credential.helper cache
```

vous évitera d'avoir à ressaisir vos identifiants/mot de passe à chaque fois.

Les commandes suivantes vous permettront de compléter une question déjà validée (par exemple la Qx):

```{shell}
git tag -d Qx
git commit -am 'Question X (complément)'
git tag Qx
git push --tag # peut être éventuellement différé en fin de tp
```


# Description du projet

On va reprendre ici le thème des comptes de vacances.

Un certain nombre d'amis (appelés participants) font une sortie. L'application que l'on se propose de réaliser aura pour objet de gérer la comptabilité du groupe:
* Enregistrer chaque dépense (appelée opéartion) faite pour le compte du groupe par un participant.
* Afficher au fur et à mesure le montant total des dépenses par poste (il y a 5 postes: TRANSPORT, HEBERGEMENT, RESTAURATION, LOISIRS, AUTRES)
* Au final afficher pour chaque participant le montant qu'il doit payer (ou recevoir) pour que chacun ait participé équitablement.

L'exemple du jeu d'essai fourni est le suivant (les valeurs calculées par le modèle sont en _italique_):

[//]: # (<div style="float:left; width:35%">)

liste des participants

| Participants |    _Solde_ | _Détail du calcul_ |
|:-------------|-----------:|:-------------------|
| Ahmed        |  _10.50 €_ | _37.50 - 27.00_    |
| Bruno        | _-27.50 €_ | _37.50 + 27.50_    |
| Marine       |  _-6.00 €_ | _37.50 - 43.50_    |
| Yasmina      |  _23.00 €_ | _37.50 - 14.50_    |

**_NOTE_** Calcul: `cumul_total / nb_participants - cumul_participant`

[//]: # (</div>)

[//]: # (<div style="float:left;width:35%">
)
liste des opérations

| Participant | Poste        | Montant |
|:------------|:-------------|--------:|
| Ahmed       | TRANSPORT    | 15.00 € |
| Bruno       | HEBERGEMENT  | 65.00 € |
| Marine      | TRANSPORT    | 43.50 € |
| Ahmed       | AUTRES       | 12.00 € |
| Yasmina     | RESTAURATION | 14.50 € |

[//]: # (</div>)

[//]: # (<div style="float:left;width:30%">)
liste des postes

| Poste        |        _Cumul_ |
|:-------------|---------------:|
| TRANSPORT    |      _58.50 €_ |
| HEBERGEMENT  |      _65.00 €_ |
| RESTAURATION |      _14.50 €_ |
| LOISIRS      |       _0.00 €_ |
| AUTRES       |      _12.00 €_ |
| **TOTAL**    | _**150.00 €**_ |

[//]: # (</div>)


[//]: # (<div style="clear:both"></div>)

## Interface de l'application

L'interface de l'application se présente sous la forme de deux activités:

### Activité principale

<img src="img/Screenshot_1.png" alt="image" style="width:200px"/>

<img src="img/offline.png" alt="image" style="width:200px"/>

* La partie supérieure de l'activité principale présente le titre de l'application ainsi que les cumul des opérations par poste.

* La partie inférieure affiche la liste des participants. Pour chaque participant, on affiche le solde dû.
    Cette partie de l'interface permet en outre
    *  d'ajouter un nouveau participant (en fournissant son pseudo)
    *  de supprimer un participant.

* Un bouton situé en bas de cette activité permet d'ouvrir la liste des opérations

### Écran des statistiques

<img src="img/Screenshot_2.png" alt="image" style="width:200px"/>

La seconde activité présente la liste des opérations et permet d'afficher
* les statistiques générales (nombre d'opérations et cumul des montants)
* les statistiques pour un poste (nombre d'opérations et cumul des montants)

## Description du modèle

Le modèle complet de données vous est fourni (vous n'aurez donc à priori à modifier aucune des classes `ModelApplication`, `Operation` ou `Participant`.
Ce modèle est intégré dans la version initiale (et partielle) de l'application android.

## Tâches à réaliser.

L'application qui vous est fournie avec ce projet est incomplète.  
Dans le cadre de ce DS, vous devez réaliser les tickets suivants:  
(pour chaque ticket et en bleu, les méthodes vous fournissant les données)
#### Q1. Afficher le cumul des dépenses par poste.  
   `getSumOperations(string)`: affiche le cumul des opérations pour un poste.

> Avant de passer à la question suivante, n'oubliez pas de `tag`/`commit` cette question.

#### Q2. Completer les classes internes `ParticipantAdapter` et `ParticipantViewHolder` pour afficher les noms des participant dans `R.id.text1`.  
   `getNbParticipants`: lire le nombre de participants.  
   `getParticipant(int)`: accès à un participant par sa position.    
   `Participant.getName()`: accesseur sur le nom du paticipant.

   > Avant de passer à la question suivante, n'oubliez pas de `tag`/`commit` cette question.
#### Q3. Afficher le solde par participant en dessous de chaque nom (utiliser le champ `TextView` dont l'id est `R.id.text2`)    
   `getBalance(String participant)`: accesseur sur le solde du participant.

   > Avant de passer à la question suivante, n'oubliez pas de `tag`/`commit` cette question.
#### Q4. Ajouter un participant.  
   L'EditText `R.id.new_participant` permet la saisie du pseudo.  
   Le bouton  `R.id.add_participant` effectuera l'ajout.  
   `addParticipant(String)`: ajouter un participant.

   > Avant de passer à la question suivante, n'oubliez pas de `tag`/`commit` cette question.
#### Q5. Si l'ajout de participant est impossible (si un participant de même pseudo existe déjà) une exception est levée.  
   Compléter la question précédente pour que ces exceptions soient récupérées et affichent une annonce (`Toast`) affichant le message lié à l'exception.

   > Avant de passer à la question suivante, n'oubliez pas de `tag`/`commit` cette question.
#### Q6. Ajouter un menu contextuel sur la liste des participants qui comporte un seul item qui permet de supprimer un participant.  
   `removeParticipant(String)`: supprimer un participant.

   > Avant de passer à la question suivante, n'oubliez pas de `tag`/`commit` cette question.

#### Q7. Créer une seconde activité qui sera lancée par n'importe lequel des boutons libellé `STATS...`  
   Cette activité se présentera sous la forme affichée ci-dessus (faire le layout complet) mais seul les statistiques générales seront présentées.  
   `getNbOperations()`: affiche le nombre d'opérations totales  
   `getSumOperation()`: affiche le cumul des montants.

   > Avant de passer à la question suivante, n'oubliez pas de `tag`/`commit` cette question.

#### Q8. Faire en sorte que l'appui sur le bouton `Fermer` fasse revenir sur l'activité initiale.

   > Avant de passer à la question suivante, n'oubliez pas de `tag`/`commit` cette question.

#### Q9. Complétez le projet de sorte que les statistiques propres à un poste soient affichées sur la partie inférieure (selon le bouton `STATS...` choisi).  
   `getSum(String)`: lire le cumul pour un poste (désigné par son nom)  
   `getNbOperations(string)`: affiche le nombre d'opérations pour un poste

   > n'oubliez pas de `tag`/`commit` cette dernière question.




   
