package fr.iutlille.ctp_2025;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.DividerItemDecoration;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;
import android.widget.Toast;

import fr.iutlille.ctp_2025.databinding.ActivityMainBinding;

public class MainActivity extends AppCompatActivity {

    public class ParticipantAdapter extends RecyclerView.Adapter<ParticipantViewHolder> {

        @NonNull
        @Override
        public ParticipantViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
            View itemView = LayoutInflater.from(parent.getContext())
                    .inflate(android.R.layout.simple_list_item_2, parent, false);
            return new ParticipantViewHolder(itemView);
        }

        @Override
        public void onBindViewHolder(@NonNull ParticipantViewHolder holder, int position) {
            Participant participant = model.getParticipant(position);
        }

        @Override
        public int getItemCount() {
            return 0;
        }
    }
    public class ParticipantViewHolder extends RecyclerView.ViewHolder {

        TextView text1;
        TextView text2;
        public ParticipantViewHolder(View itemView) {
            super(itemView);
        }

    }
    private ActivityMainBinding ui;
    private ModelApplication model;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ui = ActivityMainBinding.inflate(getLayoutInflater());
        setContentView(ui.getRoot());
        model = (ModelApplication) getApplication();
        ui.ParticipantList.setHasFixedSize(true);
        ui.ParticipantList.setAdapter(new ParticipantAdapter());
        RecyclerView.LayoutManager lm = new LinearLayoutManager(this, RecyclerView.VERTICAL, false);
        ui.ParticipantList.setLayoutManager(lm);
        ui.ParticipantList.addItemDecoration(new DividerItemDecoration(this, DividerItemDecoration.VERTICAL));
        refresh();
    }
    private void refresh() {
        model.computeBalance();
        ui.ParticipantList.getAdapter().notifyDataSetChanged();
    }
}